unit Unit1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls,
   unit2,unit3,Unit4,unit5,math;

type

	 { TForm1 }

   TForm1 = class(TForm)
			Label1: TLabel;
			Label2: TLabel;
			Panel1: TPanel;
      procedure CheckStatus;
			procedure FormActivate(Sender: TObject);
			procedure FormCreate(Sender: TObject);
			procedure FormDestroy(Sender: TObject);
			procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
				 Shift: TShiftState; X, Y: Integer);
			procedure Panel1Paint(Sender: TObject);
   private
      sl : TStringList;
   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}

const sep = ' | ';
var startup : Boolean = true;

function IndexByName (s : string) :Integer;
var who: string;
    i,p : integer;
begin
result  := -1;
p := pos (sep,s);
who := copy (s,1,p-1);
for i := 0 to Screen.FormCount-1 do
    begin
    if screen.Forms[i].Name = who then
      begin
      result := i;
      exit;
			end;
		end;
end;

function GetFormColor (s: string) : TColor;
var idx : integer;
begin
idx := IndexByName (s);
if idx < 0 then result := clNone else
   result := Screen.Forms[idx].Color;
end;



procedure TForm1.Panel1Paint(Sender: TObject);
const offxy = 8;
var i,hi : Integer;
    r : TRect;
    col : TColor;
    bw : integer; // Bevelwidth panel
begin
if startup then exit;
bw := Panel1.BevelWidth *2;
hi := (Panel1.height - 2*bw) div sl.count; // Border = 2 x 2
for i := 0 to sl.count - 1 do
   begin
   r := Rect(bw, bw+i*hi,Panel1.width - 2*bw,bw+(i+1)*hi-1);
   panel1.Canvas.Brush.color := GetFormColor(sl[i]);
   Panel1.Canvas.FillRect(r);
   Panel1.Canvas.TextOut(offxy,offxy+i*hi,sl[i]);
	 end;
end;





procedure TForm1.CheckStatus;

var hi, i : Integer;

    s : string;

begin
   hi := Screen.FormCount;
   sl.Clear;
   for i := 0 to hi - 1 do
      begin
      s := screen.Forms[i].name+sep;
      if NOT screen.Forms[i].visible then s := s + 'NOT ';
      s := s + 'visible';
      sl.add(s);
			end;
   sl.sort; // screen.Forms bringt die Reihenfolge in Unordnung
   Panel1.Invalidate;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
   startup := false;
   checkstatus;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   sl := TStringList.create;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
   sl.free;
end;

procedure TForm1.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
	 Shift: TShiftState; X, Y: Integer);
var Formidx, idx, hi,bw: integer;
begin
bw := Panel1.BevelWidth *2;
hi := (Panel1.height - 2*bw) div sl.count; // Bevel = 2 x 2
idx := y div hi;
idx := EnsureRange(idx,0,sl.count-1);
If Idx = 0 then
  begin
  showMessage ('Finger weg von der Master_Form!');
  exit;
	end;
FormIdx := IndexByName(sl[idx]);

if ssLeft  in Shift then screen.Forms[FormIdx].show;
if ssRight in shift then screen.Forms[FormIdx].close;
checkstatus;
end;




end.

